use v6.e.PREVIEW;
use Data::Record::Instance;

proto MAKETY(Str:D --> Data::Record::Instance:U) {*}
multi MAKETY('tuple') {
    require ::('Data::Record::Tuple');
    ::('Data::Record::Tuple')
}

proto MAKEOP(Str:D, +) {*}
multi MAKEOP('(><)', +types) {
    #|[ Given a record type and a data structure, wraps the data structure so that
        it can be an instance of the record type without changing its contents. ]
    proto infix:«(><)»($, $ --> Data::Record::Instance:D) {*}
    &infix:«(><)».add_dispatchee: $_
        for flat do for types -> ::D { given D.for -> ::F {
            multi infix:«(><)»(F:D $lhs is raw, D:U $rhs is raw) { $rhs.new: $lhs },
            multi infix:«(><)»(D:D $lhs is raw, D:U $rhs is raw) { $rhs.new: $lhs.record },
            multi infix:«(><)»(D:U $lhs is raw, F:D $rhs is raw) { $lhs.new: $rhs },
            multi infix:«(><)»(D:U $lhs is raw, D:D $rhs is raw) { $lhs.new: $rhs.record },
        } };
    '&infix:«(><)»' => &infix:«(><)»
}

only EXPORT(@terms = [<tuple>] --> Map:D) {
    Map.new: |[MAKEOP '(><)', @terms.map: &MAKETY]
}
